/*********************************************************************
 *	P I C b o o t
 *********************************************************************
 */

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <ctype.h>
#include <math.h>

#ifndef	_LINUX_
#include <windows.h>
#endif


#define MAIN_DEF	// for monit.h
#include "monit.h"
//#include "hidasp.h"
#include "util.h"
#include "packet.h"
#include "codebuf.h"


#define CMD_NAME "picboot.exe"
#define DEFAULT_SERIAL	"*"

char HELP_USAGE[]={
	"* ARMboot Ver 0.4 (" __DATE__ ")\n"
	"Usage is\n"
	"  " CMD_NAME " [Options] <hexfile.hex>\n"
	"Options\n"
	"  -p[:XXXX]   ...  Select serial number (default=" DEFAULT_SERIAL ").\n"
	"  -r          ...  Run after write.\n"
	"  -v          ...  Verify.\n"
	"  -E          ...  Erase.\n"
	"  -rp         ...  Read program area.\n"
//	"  -nv         ...  No-Verify.\n"
	"  -B          ...  Allow Bootloader Area to Write / Read !.\n"
	"  -sXXXX      ...  Set program start address. (default=2000)\n"
};

#define	MAX_CMDBUF	4096

static	char lnbuf[1024];
static	char usb_serial[128]=DEFAULT_SERIAL;	/* gpHIDaspx̃VAԍi[ */
static	char verbose_mode = 0;	//1:foCX_v.
		int  hidmon_mode = 1;	/* picmon s */
static	uchar 	databuf[256];
static	int		dataidx;
static	int		adr_u = 0;		// hexrec mode 4

#define	VERBOSE		1

#define	HIGH_MASK	0xffff0000

#define	READ_SIZE	64
//#define	WRITE_SIZE	(64-8)
#define	WRITE_SIZE	(56-8)
//#define	WRITE_SIZE	1024

#ifdef	LPC2388
//==LPC2388===================
#define	FLASH_BASE	0x00000000
#define	FLASH_START	0x00002000
#define	FLASH_SIZE	0x0007e000

#define	FLASH_STEP	4096
#define	ERASE_STEP	4096

#else

#ifdef	LPC1343
//==LPC1343===================
#define	FLASH_BASE	0x00000000
#define	FLASH_START	0x00002000
#define	FLASH_SIZE	0x00008000

#define	FLASH_STEP	4096
#define	ERASE_STEP	4096

#else

//==STM32=====================
#define	FLASH_BASE	0x1c000000
#define	FLASH_START	0x00000000
#define	FLASH_SIZE	0x00100000	// 1MB

#define	FLASH_STEP	1024
#define	ERASE_STEP	1024
#endif

#endif


static	uchar flash_buf[FLASH_SIZE];
static	int	  flash_start = FLASH_START;
static	int	  flash_end   = FLASH_SIZE;
static	int	  flash_end_for_read = 0x10000;


static	char  opt_r  = 0;		//	'-r '
static	char  opt_rp = 0;		//	'-rp'
static	char  opt_re = 0;		//	'-re'
static	char  opt_rf = 0;		//	'-rf'

static	char  opt_E  = 0;		//	erase
static	char  opt_v  = 0;		//	'-v'
static	char  opt_nv = 0;		//	'-nv'

//	[U[AvP[VJnԒn.
static	int   opt_s  = 0x2000;	//	'-s1000 Ȃ'

#define	CHECKSUM_CALC	(1)


#define	DEVCAPS_BOOTLOADER	0x01

void hidasp_delay_ms(int dly);
/*********************************************************************
 *	gp@\
 *********************************************************************
 */
void usage(void)
{
	fputs( HELP_USAGE, stdout );
}
/*********************************************************************
 *	s̓[eBeB
 *********************************************************************
 */
static	int getln(char *buf,FILE *fp)
{
	int c;
	int l;
	l=0;
	while(1) {
		c=getc(fp);
		if(c==EOF)  {
			*buf = 0;
			return(EOF);/* EOF */
		}
		if(c==0x0d) continue;
		if(c==0x0a) {
			*buf = 0;	/* EOL */
			return(0);	/* OK  */
		}
		*buf++ = c;l++;
		if(l>=255) {
			*buf = 0;
			return(1);	/* Too long line */
		}
	}
}
/**********************************************************************
 *	INTEL HEXR[h `01 o͂.
 **********************************************************************
 */
static	int	out_ihex01(unsigned char *data,int adrs,int cnt,FILE *ofp,int rec_id)
{
	int length, i, sum;
	unsigned char buf[1024];

	buf[0] = cnt;
	buf[1] = adrs >> 8;
	buf[2] = adrs & 0xff;
	buf[3] = rec_id;

	length = cnt+5;
	sum=0;

	memcpy(buf+4,data,cnt);
	for(i=0;i<length-1;i++) {
		sum += buf[i];
	}
	sum = 256 - (sum&0xff);
	buf[length-1] = sum;

	fprintf(ofp,":");
	for(i=0;i<length;i++) {
		fprintf(ofp,"%02X",buf[i]);
	}
	fprintf(ofp,"\n");
	return 0;
}
/**********************************************************************
 *	INTEL HEXR[h `01 (oCi[ς) ߂.
 **********************************************************************
 */
static void put_flash_buf(int adrs,int data)
{
	adrs = adrs - FLASH_BASE;
	if( (adrs >= 0) && (adrs < FLASH_SIZE ) ) {
		flash_buf[adrs] = data;
	}
}
/**********************************************************************
 *	INTEL HEXR[h `01 (oCi[ς) ߂.
 **********************************************************************
 */
static	int	parse_ihex01(unsigned char *buf,int length)
{

	int adrs = (buf[1] << 8) | buf[2];
	int cnt  =  buf[0];
	int i;
	int sum=0;

#if	CHECKSUM_CALC
	for(i=0;i<length;i++) {
		sum += buf[i];
	}
//	printf("checksum=%x\n",sum);
	if( (sum & 0xff) != 0 ) {
		fprintf(stderr,"%s: HEX RECORD Checksum Error!\n", CMD_NAME);
		exit(EXIT_FAILURE);
	}
#endif

	buf += 4;

#if	HEX_DUMP_TEST
	printf("%04x",adrs|adr_u);
	for(i=0;i<cnt;i++) {
		printf(" %02x",buf[i]);
	}
	printf("\n");
#endif

	adrs |= adr_u;
	for(i=0;i<cnt;i++) {
		put_flash_buf(adrs+i,buf[i]);
	}
	return 0;
}
/**********************************************************************
 *	INTEL HEXR[h(Ps:oCi[ς) ߂.
 **********************************************************************
 */
int	parse_ihex(int scmd,unsigned char *buf,int length)
{
	switch(scmd) {
		case 0x00:	//f[^R[h:
					//f[^tB[h͏܂ׂf[^łB
			return parse_ihex01(buf,length);

		case 0x01:	//GhR[h:
					//HEXt@C̏I.t񖳂.
			return scmd;
			break;

		case 0x02:	//ZOgAhXR[h:
					//f[^tB[hɂ̓ZOgAhXB Ƃ΁A
					//:02000002E0100C
					//		   ~~~~
					//
			break;

		case 0x03:	//X^[gZOgAhXR[h.
				//Ƃ肠.
				return scmd;
			break;

		case 0x04:	//gjAAhXR[h.
					//̃R[hł32rbgAhX̂16rbg
					//irbg32`rbg16́j^B
				adr_u = (buf[4]<<24)|(buf[5]<<16);
//				printf("adr_u=%x\n",adr_u);
				return scmd;
			break;

		case 0x05:	//X^[gjAAhXF
					//Ⴆ
					//:04000005FF000123D4
					//         ~~~~~~~~
					//ƂȂĂ΁AFF000123hԒnX^[gAhXɂȂB
				//Ƃ肠.
				return scmd;
			break;

	}
	fprintf(stderr,"Unsupported ihex cmd=%x\n",scmd);
	return 0;
}

/**********************************************************************
 *	16i2̕oCi[ɕϊ.
 **********************************************************************
 */
int read_hex_byte(char *s)
{
	char buf[16];
	int rc = -1;

	buf[0] = s[0];
	buf[1] = s[1];
	buf[2] = 0;
	sscanf(buf,"%x",&rc);
	return rc;
}

/**********************************************************************
 *	16iŏꂽoCi[ɕϊ.
 **********************************************************************
 */
static	int read_hex_string(char *s)
{
	int rc;

	dataidx = 0;
	while(*s) {
		rc = read_hex_byte(s);s+=2;
		if(rc<0) return rc;
		databuf[dataidx++]=rc;
	}
	return 0;
}

/**********************************************************************
 *	motorola-S.
 **********************************************************************
 */

int	put_srec(int adrsize,unsigned char *buf,int length)
{
	int recsize;
	int adrs=0;
	int sum=0;
	int cnt;
	int i;
	recsize = buf[0];

#if	CHECKSUM_CALC
	sum = 0;
	for(i=0;i<length;i++) {
//		printf(" %2d checksum add=%x,%x\n",i,buf[i],sum);
		sum += buf[i];
	}
//	printf("checksum=%x\n",sum);
	if( (sum & 0xff) != 0xff ) {
		fprintf(stderr,"%s: S-RECORD Checksum Error!(sum=%02x)\n", CMD_NAME,sum & 0xff);
		exit(EXIT_FAILURE);
	}
#endif

	buf++;
	for(i=0;i<adrsize;i++) {
		adrs <<= 8;
		adrs |= *buf++;
	}
	cnt = recsize - adrsize - 1;
	
	if( recsize != (length-1) ) {
		printf("WARNING:record length mismatch:%d != %d\n",recsize,(length-1));
		exit(1);
	}

#if	HEX_DUMP_TEST
	printf("%08x",adrs);
	for(i=0;i<cnt;i++) {
		printf(" %02x",buf[i]);
	}
	printf("\n");
#endif

#if	1
	for(i=0;i<cnt;i++) {
		put_flash_buf(adrs+i,buf[i]);
	}
#endif
	return 0;


#if	0
	printf("%06x",adrs);
	for(i=0;i<cnt;i++) {
		printf(" %02x",buf[i]);
	}
	printf("\n");
#endif
}

int	parse_mot(int scmd,unsigned char *buf,int length)
{
	switch(scmd) {
		case '0':
			break;
		case '1':	return put_srec(2,buf,length);
		case '2':	return put_srec(3,buf,length);
		case '3':	return put_srec(4,buf,length);

		case '7':
		case '8':
		case '9':
			break;
	}
}

static	int read_mot_string(char *s)
{
	int c = s[1];
	switch(c) {
		case '0':
		case '1':
		case '2':
		case '3':
		case '7':
		case '8':
		case '9':
			//printf("Srec %s\n",s);
			read_hex_string(s+2);	// 'S0' ɑ16ibinary.
			parse_mot(c,databuf,dataidx);
			return 0;
		default:
			printf("WARNING:garbled line:%s\n",s);
			exit(1);
	}
	return -1;
}

/**********************************************************************
 *
 **********************************************************************
 0 1 2 3 4
:1000100084C083C082C081C080C07FC07EC07DC0DC
 ~~ f[^
   ~~~~ AhX
       ~~ R[h^Cv
         ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~f[^
                                         ~~`FbNT.
 */
int	read_ihex_or_mot(char *s)
{
	int c;
	if(s[0] == ':') {
		read_hex_string(s+1);
		c = databuf[3];
		parse_ihex(c,databuf,dataidx);
		return ':';
	}
	if(s[0] == 'S') {
		read_mot_string(s);
		return 'S';
	}
	return 0;
}
/*********************************************************************
 *	HEX file ǂݍ flash_buf[] Ɋi[.
 *********************************************************************
 */
int	read_hexfile(char *fname)
{
	FILE *ifp;
	int rc;
	Ropen(fname);
	while(1) {
		rc = getln(lnbuf,ifp);
		read_ihex_or_mot(lnbuf);
		if(rc == EOF) break;
	}
	Rclose();
	return 0;
}

/*********************************************************************
 *	flash_buf[]̎wGA 0xffŖ܂Ă邱ƂmF.
 *********************************************************************
 *	܂Ă 0 Ԃ.
 */
#if	0
static	int	check_prog_ff(int start,int size)
{
	int i;
	for(i=0;i<size;i++) {
		if(flash_buf[start+i]!=0xff) return 1;
	}
	return 0;
}
#endif
/*********************************************************************
 *	
 *********************************************************************
 *	
 */
static	void modify_vector( int addr , int dst )
{
	int i;
	for(i=0;i<0x180;i++) {
		flash_buf[addr+i] = flash_buf[dst+i];	
	}
}
/*********************************************************************
 *	KvȂAflash_buf[]  0x800,0x808,0x818Ԓn.
 *********************************************************************
 */
void modify_start_addr(int start)
{
	if(start == 0x2000) return;	//ftHglȂ̂ŉȂ.

	if(start <  0x2000) {		// [U[vOJnԒn0x800ȑOɂ̂͂.
		fprintf(stderr,"WARNING: start address %x < 0x2000 ?\n",start);
		return;
	}
	// [U[t@[̗OxN^[GA(startoffsetɂȂĂ)
	// 0x2000ԒnɃRs[.

	// 邱ƂŁACӔԒn(256byte{Ԓn)Jñt@[
	// jumperɂ肻̂܂܋Nł.
	modify_vector( 0x2000 , start );
}
int	bswap16(int i)
{
	return 	((i & 0x00ff) << 8 )
		|	((i & 0xff00) >> 8 )
	;
}
int	bswap32(int i)
{
	return 	((i & 0x000000ff) << 24)
		|	((i & 0x0000ff00) << 8 )
		|	((i & 0x00ff0000) >> 8 )
		|	((i & 0xff000000) >> 24)
	;
}

int	read_block(int addr,uchar *read_buf,int size);

/*********************************************************************
 *	^[Qbg̍ċN.
 *********************************************************************
 */
int reboot_target(int vect)
{
#ifdef	LPC2388
//	ARM7 ̃xN^[ARM̕򖽗߂̂̂܂Ă.
//	RESETROM擪̖߂s.

	UsbBootTarget(vect,1);

#else
//	Cortex-M3 ̃xN^[̓AhXz񂪏܂Ă.
//	RESET ̓AhXz2ԖڂɏꂽԒnւ̕򂷂邱ƂƓ.
	int	buf[32];

	read_block(FLASH_BASE+vect,(uchar*)buf,32);
#ifdef	SH2A
	int boot_pc = BSWAP32( buf[0] );	// SH2A
#else
	int boot_pc = BSWAP32( buf[1] );	// ARM
#endif
	if(( boot_pc >= FLASH_BASE)&&
	   ( boot_pc < (FLASH_BASE+FLASH_SIZE)) ){
		printf("reset vector: %08x\n",boot_pc);
		UsbBootTarget(boot_pc,1);
	}else{
		printf("Illegal reset vector: %08x\n",boot_pc);
	}
#endif

	return 0;
}

/*********************************************************************
 *	1024 byte.
 *********************************************************************
 */
int	erase_block(int addr,int size)
{
	int i,f=0;
	int pages = size / 1024;

	for(i=0;i<size;i++) {
		if(flash_buf[addr+i]!=0xff) f=1;
	}

	if((f) || (opt_E)) {
#if	0	// TEST
		printf("UsbEraseTargetROM(%x,%x)\n",FLASH_BASE+addr , pages);
#else
		UsbEraseTargetROM(FLASH_BASE+addr , pages);
#endif
		Sleep(2);
	}
	return 0;
}

/*********************************************************************
 *	flash_buf[] ̓e ^[Qbg PIC ɏ.
 *********************************************************************
 */
int	write_block_usb_packet(int addr,int size)
{
	int i,f=0;
	for(i=0;i<size;i++) {
		if(flash_buf[addr+i]!=0xff) f=1;
	}
	if(f) {
//		UsbFlash(addr ,AREA_PGMEM,flash_buf+addr,size);
		UsbWrite(addr + FLASH_BASE ,AREA_PGMEM,flash_buf+addr,size);
	}
	return 0;
}

/*********************************************************************
 *	flash_buf[] ̓e ( 1PAGE = 1kBytes )
 *********************************************************************
 */
int	write_block_page(int addr,int size)
{
#if	defined(LPC1343)||defined(LPC2388)
	int addr0=addr;
#endif

	int wsize;
	while(size) {
		wsize = size;
		if(	wsize>= WRITE_SIZE) {
			wsize = WRITE_SIZE;		//P̏݉\TCY
		}
		write_block_usb_packet(addr,wsize);
		addr += wsize;
		size -= wsize;
	}

#if	defined(LPC1343)||defined(LPC2388)
	// FLASH 1y[W̍XVs.LPC}CR̂.
	UsbFlash(addr0 ,AREA_PGMEM , flash_buf + addr0, 0);
#endif

	return 0;
}
/*********************************************************************
 *	flash_buf[] ̓e ^[Qbg PIC ɏ.
 *********************************************************************
 *	Pʂ FLASHROM ̃y[WTCY.(STM32=1K LPC1343=4K)
 */
int	write_block(int addr,int size)
{
	int i,f=0;
	for(i=0;i<size;i++) {
		if(flash_buf[addr+i]!=0xff) f=1;
	}

	if(f) {
		write_block_page(addr,size);		// 1y[W.
		fprintf(stderr,"Writing ... %04x\r",addr);
	}
	return 0;
}
/*********************************************************************
 *	 ^[Qbg PIC ̓e flash_buf[] ɓǂݍ.
 *********************************************************************
 */
int	read_block(int addr,uchar *read_buf,int size)
{
	int errcnt=0;
	int rsize;



	while(size) {
		rsize = size;
		if(	rsize>= READ_SIZE) {
			rsize = READ_SIZE;		//P̓ǂݏo\TCY=64byte
		}
//		UsbRead(addr ,AREA_PGMEM,read_buf,rsize);
		code_buf_read(addr ,rsize ,read_buf);
		addr     += rsize;
		read_buf += rsize;
		size -= rsize;
	}
	return errcnt;
}


/*********************************************************************
 *	flash_buf[] ̓e ^[Qbg PIC ɏ.
 *********************************************************************
 */
int	verify_block(int addr,int size)
{
	uchar verify_buf[FLASH_STEP];
	int i,f=0;
	int errcnt=0;

	for(i=0;i<size;i++) {
		if(flash_buf[addr+i]!=0xff) f=1;
	}

	if(f) {
		read_block(addr,verify_buf,size);
		for(i=0;i<size;i++) {
			if(flash_buf[addr+i] != verify_buf[i]) {
				errcnt++;
				fprintf(stderr,"Verify Error in %x : write %02x != read %02x\n"
					,addr+i,flash_buf[addr+i],verify_buf[i]);
			}
		}
		fprintf(stderr,"Verifying ... %04x\r",addr);
	}
	return errcnt;
}
/*********************************************************************
 *	FLash̏.
 *********************************************************************
 */
int	erase_flash(void)
{
#if	0
	int i;
	fprintf(stderr,"Erase ... %x-%x\n",flash_start,flash_end);
	for(i=flash_start;i<flash_end;i+= ERASE_STEP) {
		erase_block(i,ERASE_STEP);
	}
#endif
	return 0;
}
/*********************************************************************
 *	_~[.
 *********************************************************************
 */
int disasm_print(unsigned char *buf,int size,int adr)
{
	unsigned short *inst = (unsigned short *)buf;
	printf("%04x %04x\n",adr,inst[0]);
	return 2;
}
/*********************************************************************
 *	flash_buf[] ̓e ^[Qbg PIC ɏ.
 *********************************************************************
 */
int	write_hexdata(void)
{
	int i;
	for(i=flash_start;i<flash_end;i+= FLASH_STEP) {
		write_block(i,FLASH_STEP);
	}
	return 0;
}
/*********************************************************************
 *	flash_buf[] ̓e ^[Qbg PIC ɏ.
 *********************************************************************
 */
int	verify_hexdata(void)
{
	int i;
	int errcnt = 0;

	fprintf(stderr,"\n");
	for(i=flash_start;i<flash_end;i+= FLASH_STEP) {
		errcnt += verify_block(i,FLASH_STEP);
	}
	return errcnt;
}
/*********************************************************************
 *	|[ĝAhX߂.i_~[j
 *********************************************************************
 */
int	portAddress(char *s)
{
	return 0;
}

/*********************************************************************
 *	ROMǂݏoʂHEXŏo͂.
 *********************************************************************
 */
#define	HEX_DUMP_STEP	16

void print_high_adrs(FILE *ofp,int addr)
{
								//":020000040000F2";
	static  uchar hi_record[64]={0x02,0x00,0x00,0x04,0x00,0x00,0xf2};
	int hi = (FLASH_BASE+addr) & HIGH_MASK;
	if(	adr_u != hi) {
		adr_u  = hi;
		hi_record[0]=adr_u >> 24;
		hi_record[1]=adr_u >> 16;
		out_ihex01(hi_record,0,2,ofp,0x04);
	}
}

void print_hex_block(FILE *ofp,int addr,int size)
{
	int i,j,f;

	print_high_adrs(ofp,addr);

	for(i=0;i<size;i+=HEX_DUMP_STEP,addr+=HEX_DUMP_STEP) {
		f = 0;
		for(j=0;j<HEX_DUMP_STEP;j++) {
			if( flash_buf[addr+j] != 0xff ) {
				f = 1;
			}
		}
		if(f) {

#if	0
			printf(":%04x",addr);
			for(j=0;j<HEX_DUMP_STEP;j++) {
				printf(" %02x",flash_buf[addr+j]);
			}
			printf("\n");
#endif
			out_ihex01(&flash_buf[addr],addr,HEX_DUMP_STEP,ofp,0x00);


		}
	}


}
/*********************************************************************
 *	ROMǂݏo.
 *********************************************************************
 */
void read_from_pic(char *file)
{
	int i, progress_on;
	FILE *ofp;
	int adr=0;
	uchar *read_buf;

//	fprintf(stderr, "Reading... (%x-%x)\n",flash_start,flash_end_for_read);
	fprintf(stderr, "Reading... \n");
	progress_on = 0;
	Wopen(file);

//	fprintf(ofp,":020000040000FA\n");

	adr_u=-1;

	for(i=flash_start;i<flash_end_for_read;i+= FLASH_STEP) {
		adr = FLASH_BASE + i;
		if (progress_on) {
			fprintf(stderr,"Reading ... %08x\r",adr);
		}
		read_buf = &flash_buf[i] ;
		read_block(adr,read_buf,FLASH_STEP);
		print_hex_block(ofp,i,FLASH_STEP);
		fflush(ofp);
	}
	fprintf(ofp,":00000001FF\n");
	if (progress_on) {
		fprintf(stderr,"\nRead end address = %08x\n", adr-1);
	}
	Wclose();
}
/*********************************************************************
 *	C
 *********************************************************************
 */
void getopt_p(char *s)
{
		if (s) {
			if (*s == ':') s++;
			if (*s == '?') {
				hidasp_list("picmon");
				exit(EXIT_SUCCESS);
			} else if (isdigit(*s)) {
				if (s) {
					int n, l;
					l = strlen(s);
					if (l < 4 && isdigit(*s)) {
						n = atoi(s);
						if ((0 <= n) && (n <= 999)) {
							sprintf(usb_serial, "%04d", n);
						} else {
							if (l == 1) {
								usb_serial[3] = s[0];
							} else if  (l == 2) {
								usb_serial[2] = s[0];
								usb_serial[3] = s[1];
							} else if  (l == 3) {
								usb_serial[1] = s[0];
								usb_serial[2] = s[1];
								usb_serial[3] = s[2];
							}
						}
					} else {
						strncpy(usb_serial, s, 4);
					}
				}
			} else if (*s == '\0'){
				strcpy(usb_serial, DEFAULT_SERIAL);		// -p݂̂̎
			} else {
				strncpy(usb_serial, s, 4);
			}
			strupr(usb_serial);
		}
}
void Flash_Unlock(void)
{
	UsbFlashLock(0);
}
void Flash_Lock(void)
{
	UsbFlashLock(1);
}
int flash_get_status();
/*********************************************************************
 *	C
 *********************************************************************
 */
int main(int argc,char **argv)
{
	int errcnt, ret_val;	//,retry;
	int dev_flash_size=0;
	int dev_flash_used=0;

	//IvV.
	Getopt(argc,argv,"i");
	if(IsOpt('h') || IsOpt('?') || IsOpt('/')) {
		usage();
		exit(EXIT_SUCCESS);
	}
	if((argc<2)&& (!IsOpt('r')) && (!IsOpt('E')) && (!IsOpt('p')) ) {
		usage();
		exit(EXIT_SUCCESS);
	}


	if(IsOpt('B')) {					// BootGA̋ǂݏ.
		flash_start = 0;
		flash_end   = FLASH_START;
	}
	if(IsOpt('E')) {
		opt_E = 1;				//.
	}
	if(IsOpt('p')) {
		getopt_p(Opt('p'));		//VAԍw.
	}
	if(IsOpt('s')) {
		sscanf(Opt('s'),"%x",&opt_s);	//AvP[V̊JnԒnw.
	}
	if(IsOpt('r')) {
		char *r = Opt('r');
		if(r[0]==0  ) opt_r = 1;		//݌ナZbg삠.
		if(r[0]=='p') opt_rp = 1;		//'-rp' flasḧ̓ǂݍ.
		if(r[0]=='e') opt_re = 1;		//'-re'
		if(r[0]=='f') opt_rf = 1;		//'-rf'
	}
	if(IsOpt('n')) {
		char *n = Opt('n');
		if(n[0]=='v') opt_nv = 1;		//'-nv' 
	}
	if(IsOpt('v')) {
		opt_v = 1;						//'-v' 
		opt_nv= 0;
	}


//  for(retry=2;retry>=0;retry--) 
  {
	//.
   if( UsbInit(verbose_mode, 0, usb_serial) == 0) {
		fprintf(stderr, "Try, UsbInit(\"%s\").\n", usb_serial);
//		if(retry==0) 
		{
			fprintf(stderr, "%s: UsbInit failure.\n", CMD_NAME);
			exit(EXIT_FAILURE);
		}
   }else{

		fprintf(stderr, "UsbInit(\"%s\") Ok.\n", usb_serial);

	if(IsOpt('B')) {
//		break;
	}

	if((UsbGetDevCaps(&dev_flash_size,&dev_flash_used) & DEVCAPS_BOOTLOADER))	{}

#if	0
	{
		break;		// BOOTLOADER@\.
	}else{
		fprintf(stderr, "Reboot firmware ...\n");
		reboot_target(0);
		Sleep(10);
		UsbExit();
	}
#endif

   }


//   Sleep(2500);
  }

//	=================================
#define	END_MASK	0xfffff

	if(!IsOpt('B')) {
		flash_end = dev_flash_size & END_MASK;				// FLASH̎e.
		flash_end_for_read = dev_flash_used & END_MASK;		// FLASH̎gpςݗe.
#if	0
		printf("flash_end=%x\n",flash_end);
		printf("flash_end_for_read=%x\n",flash_end_for_read);
#endif
	}

	Flash_Unlock();


	if((opt_E) && (argc < 2)) {					// ̎s.
		erase_flash();							//  Flash.
	}

	code_buf_init();
	memset(flash_buf,0xff,FLASH_SIZE);
	ret_val = EXIT_SUCCESS;

	if(argc>=2) {
		if(opt_rp||opt_re||opt_rf) {	// ROMǂݏo.
			read_from_pic(argv[1]);
		}else{
			read_hexfile(argv[1]);		//	HEXt@C̓ǂݍ.
			modify_start_addr( opt_s & 0x7ffff );

			if(IsOpt('v')==0) {			// xt@ĈƂ͏݂Ȃ.
				erase_flash();				//  Flash.
				write_hexdata();			//  .

				// ۔.
				int rc = flash_get_status();			// ݃G[JEg.
				if(rc==0) {
					fprintf(stderr,"\nWrite Ok.\n");opt_nv=1;
				}else{
					fprintf(stderr,"\nWrite Error (%d).\n",rc);
				}
			}


		  if(opt_nv==0) {
			errcnt = verify_hexdata();	//  xt@C.
			if(errcnt==0) {
				fprintf(stderr,"\nVerify Ok.\n");
			}else{
				fprintf(stderr,"\nVerify Error. errors=%d\n", errcnt);
				ret_val = EXIT_FAILURE;
			}
		  }
		}
	}
#if 1
	else if (argc==1) {
		if(opt_rp||opt_re||opt_rf) {	// ROMǂݏo.
			read_from_pic(NULL);
		}
	}
#endif

	Flash_Lock();

	if(opt_r) {
		reboot_target(FLASH_START);		//  ^[QbgċN.
	}
	UsbExit();
	return ret_val;
}
/*********************************************************************
 *
 *********************************************************************
 */

void ChangePortListLPC1114(void)
{
//	portList = portlist_lpc13xx;	//.
}
