/******************************************************************************
* DISCLAIMER

* This software is supplied by Renesas Technology Corp. and is only 
* intended for use with Renesas products. No other uses are authorized.

* This software is owned by Renesas Technology Corp. and is protected under 
* all applicable laws, including copyright laws.

* THIS SOFTWARE IS PROVIDED "AS IS" AND RENESAS MAKES NO WARRANTIES 
* REGARDING THIS SOFTWARE, WHETHER EXPRESS, IMPLIED OR STATUTORY, 
* INCLUDING BUT NOT LIMITED TO WARRANTIES OF MERCHANTABILITY, FITNESS FOR A 
* PARTICULAR PURPOSE AND NON-INFRINGEMENT.  ALL SUCH WARRANTIES ARE EXPRESSLY 
* DISCLAIMED.

* TO THE MAXIMUM EXTENT PERMITTED NOT PROHIBITED BY LAW, NEITHER RENESAS 
* TECHNOLOGY CORP. NOR ANY OF ITS AFFILIATED COMPANIES SHALL BE LIABLE 
* FOR ANY DIRECT, INDIRECT, SPECIAL, INCIDENTAL OR CONSEQUENTIAL DAMAGES 
* FOR ANY REASON RELATED TO THE THIS SOFTWARE, EVEN IF RENESAS OR ITS 
* AFFILIATES HAVE BEEN ADVISED OF THE POSSIBILITY OF SUCH DAMAGES.

* Renesas reserves the right, without notice, to make changes to this 
* software and to discontinue the availability of this software.  
* By using this software, you agree to the additional terms and 
* conditions found by accessing the following link:
* http://www.renesas.com/disclaimer
********************************************************************************
* Copyright (C) 2009. Renesas Technology Corp., All Rights Reserved.           *
********************************************************************************/

/*""FILE COMMENT""*********** Technical reference data *************************
 *
 *       System Name : SH7264 USB FUNCTION Sample Program
 *       File Name   : p_main.c
 *       Abstract    : Peripheral Sample Program Main
 *       Version     : 1.01.00
 *       Device      : SH7264/SH7262
 *       Tool-Chain  : High-performance Embedded Workshop (Ver.4.04.01).
 *                   : C/C++ compiler package for the SuperH RISC engine family
 *                   :                             (Ver.9.02 Release00).
 *       OS          : None
 *       H/W Platform: M3A-HS64G50(CPU board)
 *
 *       History     : May.13,2009 ver.1.00.00
 *                   : Dec.25,2009 ver.1.01.00 CDCΉ
 *""FILE COMMENT END""**********************************************************/
#include <machine.h>
#include <stdio.h>
#include "usb.h"
#include "../../monitor/usbio.h"
#include "../../monitor/monit.h"

/* ==== }N` ==== */
#define BULK_OUT_PIPE	PIPE1
#define BULK_IN_PIPE	PIPE2
#define RCV_BUFSIZE		512

/* Mobt@ i[oCgێϐ(O[oϐ) */
static int recvcheck = 0;					/* M`FbNXe[gϐ(VKǉ) */
static int rsz = 0;							// MTCY.

static unsigned char recvbuf[RCV_BUFSIZE];	// Mobt@.


/* ==== vg^Cv錾 ==== */
int  CDC_start_snd( unsigned long size, unsigned char *top );	// MJn.
int  CDC_start_rcv( unsigned long size, unsigned char *buf );	// MJn.
int  CDC_check_complete( unsigned short Pipe );					//(M)҂.









/*----------------------------------------------------------------------------- 
 * Description : 
 				 USB-CDCfoCX ConfigureI܂ő҂.
 *----------------------------------------------------------------------------- 
 */

void	CDC_start_check(void)
{
	while ( P_IsConfigured() != USB_YES ) {
		led_blink(15);
	}
	led_on();
}

void usbModuleDisable(void);

/*----------------------------------------------------------------------------- 
 * Description : USB-CDCǂݍ݊JnLbN.

   Ăяo^C~O.
	iPjCMT0荞݂̌Ăяo. ( 1mSԊu . ŏ̂ ^iQj̒fĊJ邽)
	iQjMcallback.         (AMFIFOtɂȂꍇ͒f)

 *----------------------------------------------------------------------------- 
 */
void CDC_recv_kick(void)
{
	// ML[RCV_BUFSIZE ȉ̏ꍇ́AkickoȂ.
	//		(tHAOEhf[^܂łƑ҂.)
	if( USBgetfreesize() < RCV_BUFSIZE ) { return; }

	if (recvcheck == 0) {
		if ( rsz <= 0 ) {
			/* MJn */
			if( CDC_start_rcv( RCV_BUFSIZE, recvbuf ) == 0 ){
				recvcheck = 1;
			}
		}
	}
}

/*----------------------------------------------------------------------------- 
 * Description : BULK_OUT_PIPEɎMꂽf[^̃oCgԂ܂.
 				 pƂāAtO recvcheck NA܂.
 *----------------------------------------------------------------------------- 
 */
static int CDC_recv_rsz(void)
{
	/* MmF */
	if (CDC_check_complete(BULK_OUT_PIPE)){
		/* M */
		rsz = RCV_BUFSIZE - USBDataCount[ BULK_OUT_PIPE ];
		recvcheck = 0;
		return rsz;
	} else {
		return 0;
	}
}
/*----------------------------------------------------------------------------- 
 * Description : 
                 MUSB-CDCf[^FIFOɗ߂܂.
 *----------------------------------------------------------------------------- 
 */
int CDC_rcv_queue(int size)
{
	/* ==== obt@Mf[^ size oCgo ==== */
	if(size >= rsz) {size=rsz;}
	USBenqueue(recvbuf,size);
	rsz = 0;
	return size;
}

//
// USB-CDCǂݍ݊JnLbN.
//		CMT0荞݂̌Ăяo.
//
void CDC_read_kick(void)
{
	if( P_IsConfigured() != USB_YES ) return;

	CDC_recv_kick();
}

/*----------------------------------------------------------------------------- 
 * Description : hostPC瑗ĂBULK]̓ǂݏoɌĂяo܂.
                (usb_firm\src\common\c_intrn.c:100 ̌Ăяo).
                 MUSB-CDCf[^FIFOɗ߂āA̎MLbN܂.
 *----------------------------------------------------------------------------- 
 */
int	USB_read_end_callback(USB_U16 pipe)
{
	if( pipe != BULK_OUT_PIPE) return 0;

	int size = CDC_recv_rsz();
	if(	size > 0) {
		CDC_rcv_queue(size);
		rsz=0;
		CDC_recv_kick();
	}
	return 0;
}

/*""FUNC COMMENT""************************************************************ 
* ID          : 
* Outline     : f[^MJn
*----------------------------------------------------------------------------- 
* Include     : 
*----------------------------------------------------------------------------- 
* Declaration : int CDC_start_snd( unsigned long size, unsigned char *top );
*----------------------------------------------------------------------------- 
* Description : oNIN]gpāAŎw肳ꂽf[^TCY̑M
*             : f[^USBzXgɑM܂BM̊͑҂ɌĂяo
*             : ߂܂B
*----------------------------------------------------------------------------- 
* Argument    : unsigned long size : I ; Mf[^TCY
*             : unsigned char *top : I ; Mf[^̐擪AhX
*----------------------------------------------------------------------------- 
* Return Value:  0 : MN
*             : -1 : MG[
*----------------------------------------------------------------------------- 
* Notice      : 
*""FUNC COMMENT END""*********************************************************/
int CDC_start_snd( unsigned long size, unsigned char *top )
{
	USB_U16		buffer;
	USB_U16 	pipe = BULK_IN_PIPE;

	/* ---- STALL̏ꍇ̓G[Ԃ ---- */
	buffer = usb_get_pid(pipe);
	if( ( buffer == PID_STALL ) || (buffer == PID_STALL2) ) {
		return -1;
	}
	/* ---- O̎MĂȂꍇ̓G[Ԃ ---- */
	if( (PipeFlag[pipe] != PIPE_IDLE) && (PipeFlag[pipe] != PIPE_DONE) ){
		return -1;
	}
	/* ---- MJnioNIN]j ---- */
	PipeFlag[pipe] = PIPE_WAIT;
	usb_start_send_transfer(pipe, size, top);
	return 0;
}
/*""FUNC COMMENT""************************************************************ 
* ID          : 
* Outline     : f[^MJn
*----------------------------------------------------------------------------- 
* Include     : 
*----------------------------------------------------------------------------- 
* Declaration : int CDC_start_rcv( unsigned long size, unsigned char *buf );
*----------------------------------------------------------------------------- 
* Description : oNOUT]gpāAŎw肳ꂽf[^TCY̎M
*             : f[^USBzXgM܂BM̊͑҂ɌĂяo
*             : ߂܂B
*----------------------------------------------------------------------------- 
* Argument    : unsigned long size : I ; Mf[^TCY
*             : unsigned char *buf : O ; Mobt@̐擪AhX
*----------------------------------------------------------------------------- 
* Return Value:  0 : MN
*             : -1 : MG[
*----------------------------------------------------------------------------- 
* Notice      : 
*""FUNC COMMENT END""*********************************************************/
int CDC_start_rcv( unsigned long size, unsigned char *buf )
{
	USB_U16		buffer;
	USB_U16 	pipe = BULK_OUT_PIPE;
	
	/* ---- STALL̏ꍇ̓G[Ԃ ---- */
	buffer = usb_get_pid(pipe);
	if( ( buffer == PID_STALL ) || (buffer == PID_STALL2) ) {
//		BLUELED_on();
		return -1;
	}
	/* ---- O̎MĂȂꍇ̓G[Ԃ ---- */
	if( (PipeFlag[pipe] != PIPE_IDLE) && (PipeFlag[pipe] != PIPE_DONE) ){
		return -1;
	}
//	WHITELED_on();
	/* ---- MJnioNOUT]j ---- */
	PipeFlag[pipe] = PIPE_WAIT;
	usb_start_recieve_transfer( pipe, size, buf );
	return 0;
}
/*""FUNC COMMENT""************************************************************ 
* ID          : 
* Outline     : ]̊mF
*----------------------------------------------------------------------------- 
* Include     : 
*----------------------------------------------------------------------------- 
* Declaration : int CDC_check_complete( unsigned short pipe );
*----------------------------------------------------------------------------- 
* Description : Ŏw肵pCv̓]Ăꍇ́A]Ԃ܂B
*----------------------------------------------------------------------------- 
* Argument    : unsigned short pipe : I ; pCvԍ
*----------------------------------------------------------------------------- 
* Return Value: 1 : ]
*             : 0 : ] ܂ STALL/G[
*----------------------------------------------------------------------------- 
* Notice      : 
*""FUNC COMMENT END""*********************************************************/
int CDC_check_complete( unsigned short pipe )
{
	if( (PipeFlag[pipe] == PIPE_IDLE) || (PipeFlag[pipe] == PIPE_DONE) ){
		return 1;
	}
	return 0;
}

/* End of File */
